package echo;

import java.net.*;
import java.io.*;

public class EchoServer {
	public static void main(String[] args) {
		int cnt = 0;
		try {
			ServerSocket echod = new ServerSocket(7);
			while (true) {
				System.out.println("Warte auf Verbindungen auf Port 7...");
				Socket socket = echod.accept();
				new EchoClientThread(++cnt, socket).start();
				System.out.println("Verbindungen aufgebaut: " + cnt);
			}
		} catch (IOException e) {
			System.err.println(e.toString());
			System.exit(1);
		}
	}
}

class EchoClientThread extends Thread {
	
	private int name;
	private Socket socket;

	public EchoClientThread(int name, Socket socket) {
		this.name = name;
		this.socket = socket;
	}

	public void run() {
		try {
			InputStream in = socket.getInputStream();
			OutputStream out = socket.getOutputStream();
			int c;
			while ((c = in.read()) != -1) {
				out.write((char) c);
				System.out.print((char) c);
			}
		} catch (IOException e) {
			// Log exception
		} finally {
			if (socket != null) {
				try {
					socket.close();
				} catch (IOException e) {
				}
			}
		}
	}
}
