package ip;
import inout.In;
import inout.Out;

import java.net.InetAddress;
import java.net.UnknownHostException;

public class TestInetAddress {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		InetAddress addr = null; 
		
		while (true) {
			Out.print("IP: "); 
			String addrS = In.readWord(); 
			addr = getHost(addrS); 
			printOutInetAddress(addr); 
		}
	}
	
	private static void printOutInetAddress(InetAddress addr) {
		Out.println("Canonical: " + addr.getCanonicalHostName()); 
		Out.println("Name: " + addr.getHostName()); 
		Out.println("Host address: " + addr.getHostAddress()); 
		Out.print("Address: "); 
		printIP(addr.getAddress()); 
		
	}

	private static void printIP(byte[] address) {
		for (byte b: address) {
			Out.print((byte)b); 
			Out.print(".");
		}
		Out.println(); 
	}

	private static InetAddress getHost(String name) {
		try {
			if (name.startsWith("local")) {
				return InetAddress.getLocalHost();
			} else {
				return InetAddress.getByName(name); 
			}
		} catch (UnknownHostException e) {
			e.printStackTrace();
			return null; 
		}
	}


}
