package mail;

import inout.In;
import inout.Out;

import java.net.*;
import java.text.DateFormat;
import java.util.Date;
import java.io.*;

public class SMTPMailClient {
	public static void main(String[] args) {
        Socket mailSocket = null;
        BufferedReader in = null;
        PrintWriter out = null;

        try {
			Out.print("--> Addresse des Mail-Servers: ");
			String addrS = In.readLine();
            mailSocket = new Socket(addrS, 25);
            
			Out.print("--> Absender: ");
			String sender = In.readLine();

			Out.print("--> Empfaenger: ");
			String recipient = In.readLine();

			Out.print("--> Betreff: ");
			String subject = In.readLine();

            out = new PrintWriter(mailSocket.getOutputStream());
            in = new BufferedReader(new InputStreamReader(mailSocket.getInputStream()));

            receive(in); 
            String hostName = InetAddress.getLocalHost().getHostName();
            send(out, "HELO " + hostName);
            receive(in); 
            send(out, "MAIL FROM: <" + sender + ">");
            receive(in); 
            send(out, "RCPT TO: <" + recipient + ">");
            receive(in); 
            send(out, "DATA");
            receive(in); 
            send(out, "From: " + sender);
            send(out, "To: " + recipient);
            send(out, "Date: " + DateFormat.getDateTimeInstance().format(new Date())); 
            send(out, "Subject: " + subject);
            send(out, "");
            Out.print("--> Zeile (Ende mit \"Ende\"): "); 
            String line = In.readLine(); 
            while (! line.equalsIgnoreCase("Ende")) {
            	send(out, line); 
                Out.print("--> Zeile (Ende mit \"Ende\"): "); 
                line = In.readLine(); 
            }
            send(out, ".");
            receive(in); 
            send(out, "Quit");
            receive(in);
        }
        catch (UnknownHostException e) { 
        	Out.println("UnkownHost! " + e.toString()); 
        }
        catch (IOException e) { 
        	Out.println("IOException! " + e.toString()); 
       }
        finally { 
        	if (mailSocket != null) { 
        		try { 
        			mailSocket.close(); 
        		} catch (IOException e) {
        			
        		}
        	}
        }
    }

	/**
	 * Receives a line from BufferedReader in
	 * 
	 * @param in
	 * @return
	 * @throws IOException
	 */
	private static String receive(BufferedReader in) throws IOException {
		String str = in.readLine();
		if (str == null) {
			str = "";
		}
		System.out.println("smtp (receiving):" + str);
		return str;
	}

	/**
	 * Sends a line to PrintWriter out
	 * 
	 * @param out
	 * @param str
	 * @throws IOException
	 */
	private static void send(PrintWriter out, String str) throws IOException {
		out.print(str);
		System.out.println("smtp (sending): " + str);
		out.print("\r\n");
		out.flush();
	}

}
